# Full withdrawal

On tanX, which is a spot trading system, the only forced action is a withdrawal of all the funds. This guarantees that tanX, which is a L2 application cannot block users from getting their funds, which is an essential attribute of a DeFi application.

This section describes the specific parameters of a Full Withdrawal request.

### Full Withdrawal parameters

When a User wants to perform Full Withdrawal, s/he calls the `fullWithdrawalRequest`function in Starkware contract. This function gets two parameters: `starkKey` and `vaultId`. The request is valid only if the `starkKey` parameter is associated with the Ethereum address that initiated the transaction. Otherwise, the request is rejected by the Starkware smart contract (and won’t be treated by tanX).


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.tanx.fi/tech/tech-docupaper/transactional-flow/full-withdrawal.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
